2019-02-16 05:05:43 +00:00
#!/bin/bash
2019-04-05 21:53:33 +00:00
# This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
2019-02-16 05:05:43 +00:00
#
# Supported OS: Windows 10, Linux64 bit
2019-07-17 11:51:34 +00:00
# Beta OS: Linux32 bit
2019-02-16 05:05:43 +00:00
#
# Linux:
#
# Windows:
2019-04-05 21:53:33 +00:00
# To execute this script you gonna need few things on your Windows machine
2019-02-16 05:05:43 +00:00
#
# Linux Subsystem Ubuntu
# 1. Follow these instructions
2019-07-22 13:49:15 +00:00
# 2. Open Ubuntu bash and get latest updates with 'apt-get update'
2019-02-16 05:05:43 +00:00
# 3. Install zip with 'apt-get install zip'
2019-07-22 13:49:15 +00:00
# 4. Install python3 with 'apt-get install python3'
# 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
2021-01-08 10:01:17 +00:00
# Do not install 'python' as python 2.x has end of life see https://pythonclock.org/
2019-07-22 13:49:15 +00:00
# 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
2019-02-16 05:05:43 +00:00
#
# export OS="Linux"
# export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
# export GPG_TTY=$(tty)
#
# and confirm them. Restart Ubuntu bash
#
# Or GIT-BASH
# 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
# 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
# 3. Download and install 7z-zip from its official website.
# By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
# 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
# you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
#
2019-04-05 21:53:33 +00:00
# Useful things to edit and compare your custom Firmware
2019-02-16 05:05:43 +00:00
# 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
# 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
#
2019-04-05 21:53:33 +00:00
# Example for MK3: open git bash and change to your Firmware directory
2021-01-08 10:01:17 +00:00
# <username>@<machine name> MINGW64 /<drive>/path
2019-02-16 05:05:43 +00:00
# bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
#
2019-04-05 21:53:33 +00:00
# Example for MK25: open git bash and change to your directory
2019-02-16 05:05:43 +00:00
# gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
# bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
#
# The compiled hex files can be found in the folder above like from the example
# gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
# FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
#
2019-07-17 11:51:34 +00:00
# Why make Arduino IDE portable?
# To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
# - Changes made to other Arduino instances do not change anything in this build environment.
# By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
# But in this case we need a stable and defined build environment, so keep it separated it kind of important.
# Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
# it will use the default Arduino IDE folders and so can corrupt the build environment.
#
2021-06-17 18:59:35 +00:00
# Version: 1.2.0-Build_54
2019-02-16 05:05:43 +00:00
# Change log:
# 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
2019-04-05 21:53:33 +00:00
# 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
2019-07-17 11:51:34 +00:00
# 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
2019-02-16 05:05:43 +00:00
# 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
# 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
2021-01-08 10:01:17 +00:00
# 10 Feb 2019, 3d-gussner, 1st tests with English only
# 10 Feb 2019, ropaha, added compiling of all variants and English only
2019-02-16 05:05:43 +00:00
# 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
# 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
# 11 Feb 2019, 3d-gussner, Ready for RC
# 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
# 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
# Also added different BUILD_ENV folders depending on OS used so Windows
# Users can use git-bash AND Windows Linux Subsystems at the same time
# Cleanup compiler flags is only depends on OS version.
# 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
# 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
# 15 Feb 2019, 3d-gussner, Added more checks if
# Compiled Hex-files
# Configuration_prusa.h
# language build files
# multi language firmware files exist and clean them up
2021-01-08 10:01:17 +00:00
# 15 Feb 2019, 3d-gussner, Fixed selection GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
2019-02-16 05:05:43 +00:00
# 15 Feb 2019, 3d-gussner, Added some colored output
# 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
2019-02-16 07:04:45 +00:00
# 16 Feb 2019, 3d-gussner, Script can be run using arguments
# $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
2021-01-08 10:01:17 +00:00
# $2 = multi language OR English only [ALL/EN_ONLY]
2019-02-16 07:04:45 +00:00
# $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
# If one argument is wrong a list of valid one will be shown
2021-01-08 10:01:17 +00:00
# 13 Mar 2019, 3d-gussner, MKbel updated the Linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
2019-03-13 20:01:56 +00:00
# So did I
2019-07-17 11:51:34 +00:00
# 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
2021-02-12 19:12:37 +00:00
# - Split the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
2019-07-17 11:51:34 +00:00
# --> less download volume needed and saves some time
#
2021-01-08 10:01:17 +00:00
# 13 Jul 2019, deliopoulos,Splitting of Arduino IDE and Prusa parts also for Linux64
2019-07-17 11:51:34 +00:00
# 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
# MacOS could be added in future if needs
# 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
2021-01-08 10:01:17 +00:00
# 15 Jul 2019, 3d-gussner, New PF-build-env GitHub branch
# 16 Jul 2019, 3d-gussner, New Arduino_boards GitHub fork
2019-07-22 13:49:15 +00:00
# 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
# 18 Jul 2019, 3d-gussner, Added python check
# 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
# 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
2021-01-08 10:01:17 +00:00
# 22 Jul 2019, 3d-gussner, Modified checks to check folder and/or installation output exists.
2019-07-22 13:49:15 +00:00
# 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
# 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
2021-01-08 10:01:17 +00:00
# 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers repository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
2019-07-23 22:10:32 +00:00
# 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
# Changed Hex-files folder to PF-build-hex as requested in PR
# 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
2019-07-26 08:35:11 +00:00
# 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
2021-01-08 10:01:17 +00:00
# 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for coming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
# 17 Oct 2019, 3d-gussner, Changed folder and check file names to have separated build environments depending on Arduino IDE version and
2019-12-15 16:27:15 +00:00
# board-versions.
# 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
2021-01-08 10:01:17 +00:00
# 15 Dec 2019, 3d-gussner, Fix Arduino user preferences for the chosen board.
2019-12-17 13:05:39 +00:00
# 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
2020-04-28 11:39:06 +00:00
# 28 Apr 2020, 3d-gussner, Added RC3 detection
2020-05-03 12:19:38 +00:00
# 03 May 2020, deliopoulos, Accept all RCx as RC versions
2020-05-06 08:54:16 +00:00
# 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
2021-01-08 10:01:17 +00:00
# After compiling All multi-language variants it makes it easier to find missing or unused translations.
2020-05-12 20:23:40 +00:00
# 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
2020-05-13 18:51:13 +00:00
# 13 May 2020, leptun , If cleanup files do not exist don't try to.
2020-10-01 14:49:38 +00:00
# 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
2021-01-08 10:01:17 +00:00
# Change Build number to script commits 'git rev-list --count HEAD PF-build.sh'
2020-10-02 16:54:18 +00:00
# 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
2020-10-05 11:18:18 +00:00
# 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
# Install needed apps under linux if needed.
2020-10-05 13:25:54 +00:00
# Clean PF-Firmware build when changing git branch
2020-11-02 13:54:16 +00:00
# 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
# Add argument to change build number automatically to current commit or define own number
# Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
2021-01-08 10:37:47 +00:00
# 08 Jan 2021, 3d-gussner, Comment out 'sudo' auto installation
# Add '-?' '-h' help option
2021-01-27 11:43:41 +00:00
# 27 Jan 2021, 3d-gussner, Add `-c`, `-p` and `-n` options
2021-02-12 19:12:37 +00:00
# 12 Feb 2021, 3d-gussner, Add MK404-build.sh
# 13 Feb 2021, 3d-gussner, Indentations
2021-02-13 09:35:34 +00:00
# 13 Feb 2021, 3d-gussner, MK404 improvements like "flash" MK3, MK3S languages files to MK404 xflash.
2021-03-01 07:25:33 +00:00
# 27 Feb 2021, 3d-gussner, Add './lang-community.sh' and update exits
2021-05-03 06:24:02 +00:00
# 03 May 2021, 3d-gussner, Update exit numbers
# 01-14 prepare build env
# 21-32 prepare compiling
# 41-47 compiling
# 51-54 cleanup
# 61-62 MK404
# 03 May 2021, 3d-gussner, Update documentation and change version to v1.2.0
2021-05-03 18:01:48 +00:00
# 03 May 2021, 3d-gussner, Add SIM atmega404
2021-06-17 17:08:55 +00:00
# 17 Jun 2021, 3d-gussner, Update PF-build.sh to work after DRracer Remove FW version parsing PR
2021-06-17 18:59:35 +00:00
# 17 Jun 2021, 3d-gussner, Save ELF files for FW3.10.1 debugging PRs
# 17 Jun 2021, 3d-gussner, Add verbose_IDE to output more information during build
2020-11-02 13:54:16 +00:00
2019-07-17 11:51:34 +00:00
#### Start check if OSTYPE is supported
2019-07-23 22:10:32 +00:00
OS_FOUND = $( command -v uname)
case $( " ${ OS_FOUND } " | tr '[:upper:]' '[:lower:]' ) in
linux*)
TARGET_OS = "linux"
; ;
msys*| cygwin*| mingw*)
# or possible 'bash on windows'
TARGET_OS = 'windows'
; ;
nt| win*)
TARGET_OS = 'windows'
; ;
*)
TARGET_OS = 'unknown'
; ;
esac
2019-07-17 11:51:34 +00:00
# Windows
2019-07-23 22:10:32 +00:00
if [ $TARGET_OS = = "windows" ] ; then
2021-02-12 19:12:37 +00:00
if [ $( uname -m) = = "x86_64" ] ; then
echo " $( tput setaf 2) Windows 64-bit found $( tput sgr0) "
Processor = "64"
elif [ $( uname -m) = = "i386" ] ; then
echo " $( tput setaf 2) Windows 32-bit found $( tput sgr0) "
Processor = "32"
else
echo " $( tput setaf 1) Unsupported OS: Windows $( uname -m) "
echo " Please refer to the notes of build.sh $( tput sgr0) "
exit 1
fi
2019-07-24 11:14:59 +00:00
# Linux
2019-07-23 22:10:32 +00:00
elif [ $TARGET_OS = = "linux" ] ; then
2021-02-12 19:12:37 +00:00
if [ $( uname -m) = = "x86_64" ] ; then
echo " $( tput setaf 2) Linux 64-bit found $( tput sgr0) "
Processor = "64"
elif [ [ $( uname -m) = = "i386" || $( uname -m) = = "i686" ] ] ; then
echo " $( tput setaf 2) Linux 32-bit found $( tput sgr0) "
Processor = "32"
else
echo " $( tput setaf 1) Unsupported OS: Linux $( uname -m) "
echo " Please refer to the notes of build.sh $( tput sgr0) "
exit 1
fi
2019-02-16 05:05:43 +00:00
else
2021-02-12 19:12:37 +00:00
echo " $( tput setaf 1) This script doesn't support your Operating system! "
echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
echo " Read the notes of build.sh $( tput sgr0) "
exit 1
2019-02-16 05:05:43 +00:00
fi
sleep 2
2019-07-17 11:51:34 +00:00
#### End check if OSTYPE is supported
#### Prepare bash environment and check if wget, zip and other needed things are available
# Check wget
2019-02-16 05:05:43 +00:00
if ! type wget > /dev/null; then
2021-02-12 19:12:37 +00:00
echo " $( tput setaf 1) Missing 'wget' which is important to run this script "
echo " Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget $( tput sgr0) "
exit 2
2019-02-16 05:05:43 +00:00
fi
2019-07-17 11:51:34 +00:00
# Check for zip
2019-02-16 05:05:43 +00:00
if ! type zip > /dev/null; then
2021-02-12 19:12:37 +00:00
if [ $TARGET_OS = = "windows" ] ; then
echo " $( tput setaf 1) Missing 'zip' which is important to run this script "
echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
echo "Run git Bash under Administrator privilege and"
echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
echo " you can run the command $( tput setaf 2) ln -s /c/Program Files/7-Zip/7z.exe zip.exe $( tput sgr0) "
exit 3
elif [ $TARGET_OS = = "linux" ] ; then
echo " $( tput setaf 1) Missing 'zip' which is important to run this script "
echo " install it with the command $( tput setaf 2) 'sudo apt-get install zip' $( tput sgr0) "
#sudo apt-get update && apt-get install zip
exit 3
fi
2019-02-16 05:05:43 +00:00
fi
2019-07-17 11:51:34 +00:00
# Check python ... needed during language build
2019-07-22 13:49:15 +00:00
if ! type python > /dev/null; then
2021-02-12 19:12:37 +00:00
if [ $TARGET_OS = = "windows" ] ; then
echo " $( tput setaf 1) Missing 'python3' which is important to run this script "
exit 4
elif [ $TARGET_OS = = "linux" ] ; then
echo " $( tput setaf 1) Missing 'python' which is important to run this script "
echo "As Python 2.x will not be maintained from 2020 please,"
echo " install it with the command $( tput setaf 2) 'sudo apt-get install python3'. "
echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
echo " Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default. $( tput sgr0) "
#sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
exit 4
fi
2019-07-22 13:49:15 +00:00
fi
2019-07-17 11:51:34 +00:00
2020-11-02 13:54:16 +00:00
# Check gawk ... needed during language build
if ! type gawk > /dev/null; then
2021-04-29 17:23:52 +00:00
if [ $TARGET_OS = = "linux" ] ; then
echo " $( tput setaf 1) Missing 'gawk' which is important to run this script "
echo " install it with the command $( tput setaf 2) 'sudo apt-get install gawk'. "
#sudo apt-get update && apt-get install gawk
exit 5
fi
2020-11-02 13:54:16 +00:00
fi
2019-12-17 13:05:39 +00:00
#### End prepare bash / Linux environment
2019-02-16 05:05:43 +00:00
2021-04-18 18:28:08 +00:00
# Check for options/flags
2021-06-17 18:59:35 +00:00
while getopts b:c:d:f:g:h:i:j:l:m:n:o:p:v:x:?h flag
2021-05-03 12:14:47 +00:00
do
case " ${ flag } " in
b) build_flag = ${ OPTARG } ; ;
2021-05-03 18:01:48 +00:00
c) clean_flag = ${ OPTARG } ; ;
d) devel_flag = ${ OPTARG } ; ;
2021-04-18 18:28:08 +00:00
f) board_flash_flag = ${ OPTARG } ; ;
2021-05-03 18:01:48 +00:00
g) graphics_flag = ${ OPTARG } ; ;
h) help_flag = 1; ;
i) IDE_flag = ${ OPTARG } ; ;
2021-06-17 18:59:35 +00:00
j) verbose_IDE_flag = ${ OPTARG } ; ;
2021-05-03 18:01:48 +00:00
l) language_flag = ${ OPTARG } ; ;
m) mk404_flag = ${ OPTARG } ; ;
n) new_build_flag = ${ OPTARG } ; ;
2021-05-03 12:14:47 +00:00
o) output_flag = ${ OPTARG } ; ;
p) prusa_flag = ${ OPTARG } ; ;
2021-05-03 18:01:48 +00:00
v) variant_flag = ${ OPTARG } ; ;
x) board_mem_flag = ${ OPTARG } ; ;
2021-05-03 12:14:47 +00:00
?) help_flag = 1; ;
esac
done
2021-04-18 18:28:08 +00:00
#
# '?' 'h' argument usage and help
if [ " $help_flag " = = "1" ] ; then
echo "***************************************"
2021-06-17 18:59:35 +00:00
echo "* PF-build.sh Version: 1.2.0-Build_54 *"
2021-04-18 18:28:08 +00:00
echo "***************************************"
echo "Arguments:"
echo " $( tput setaf 2) -b $( tput sgr0) Build/commit number ' $( tput setaf 2) Auto $( tput sgr0) ' needs git or a number "
echo " $( tput setaf 2) -c $( tput sgr0) Do not clean up lang build' $( tput setaf 2) 0 $( tput sgr0) ' no ' $( tput setaf 2) 1 $( tput sgr0) ' yes "
2021-05-03 18:01:48 +00:00
echo " $( tput setaf 2) -d $( tput sgr0) Devel build ' $( tput setaf 2) GOLD $( tput sgr0) ', ' $( tput setaf 2) RC $( tput sgr0) ', ' $( tput setaf 2) BETA $( tput sgr0) ', ' $( tput setaf 2) ALPHA $( tput sgr0) ', ' $( tput setaf 2) DEBUG $( tput sgr0) ', ' $( tput setaf 2) DEVEL $( tput sgr0) ' and ' $( tput setaf 2) UNKNOWN $( tput sgr0) ' "
echo " $( tput setaf 2) -f $( tput sgr0) Board flash size ' $( tput setaf 2) 256 $( tput sgr0) ',' $( tput setaf 2) 384 $( tput sgr0) ',' $( tput setaf 2) 512 $( tput sgr0) ',' $( tput setaf 2) 1024 $( tput sgr0) '' $( tput setaf 2) 32M $( tput sgr0) ' "
echo " $( tput setaf 2) -g $( tput sgr0) Start MK404 grafics ' $( tput setaf 2) 0 $( tput sgr0) ' no ' $( tput setaf 2) 1 $( tput sgr0) ' lite ' $( tput setaf 2) 2 $( tput sgr0) ' fancy "
echo " $( tput setaf 2) -h $( tput sgr0) Help "
echo " $( tput setaf 2) -i $( tput sgr0) Arduino IDE version ' $( tput setaf 2) 1.8.5 $( tput sgr0) ', ' $( tput setaf 2) 1.8.13 $( tput sgr0) ' "
2021-06-17 18:59:35 +00:00
echo " $( tput setaf 2) -j $( tput sgr0) Arduino IDE verbose output ' $( tput setaf 2) 0 $( tput sgr0) ', ' $( tput setaf 2) 1 $( tput sgr0) active' "
2021-05-03 18:01:48 +00:00
echo " $( tput setaf 2) -l $( tput sgr0) Languages ' $( tput setaf 2) ALL $( tput sgr0) ' for multi language or ' $( tput setaf 2) EN_ONLY $( tput sgr0) ' for English only "
echo " $( tput setaf 2) -m $( tput sgr0) Start MK404 sim ' $( tput setaf 2) 0 $( tput sgr0) ' no ' $( tput setaf 2) 1 $( tput sgr0) ' yes ' $( tput setaf 2) 2 $( tput sgr0) ' with MMU2 "
2021-04-18 18:28:08 +00:00
echo " $( tput setaf 2) -n $( tput sgr0) New fresh build ' $( tput setaf 2) 0 $( tput sgr0) ' no ' $( tput setaf 2) 1 $( tput sgr0) ' yes "
2021-05-03 18:01:48 +00:00
echo " $( tput setaf 2) -o $( tput sgr0) Output ' $( tput setaf 2) 1 $( tput sgr0) ' force or ' $( tput setaf 2) 0 $( tput sgr0) ' block output and delays "
echo " $( tput setaf 2) -p $( tput sgr0) Keep Configuration_prusa.h ' $( tput setaf 2) 0 $( tput sgr0) ' no ' $( tput setaf 2) 1 $( tput sgr0) ' yes "
echo " $( tput setaf 2) -v $( tput sgr0) Variant ' $( tput setaf 2) All $( tput sgr0) ' or variant file name "
echo " $( tput setaf 2) -x $( tput sgr0) Board memory size ' $( tput setaf 2) 8 $( tput sgr0) ' or ' $( tput setaf 2) 64 $( tput sgr0) ' Kb. "
2021-04-18 18:28:08 +00:00
echo " $( tput setaf 2) -? $( tput sgr0) Help "
echo
echo "Brief USAGE:"
echo " $( tput setaf 2) ./PF-build.sh $( tput sgr0) [-v] [-l] [-d] [-b] [-o] [-c] [-p] [-n] "
echo
echo "Example:"
echo " $( tput setaf 2) ./PF-build.sh -v All -l ALL -d GOLD $( tput sgr0) "
echo " Will build all variants as multi language and final GOLD version"
echo
echo " $( tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1 -c 1 -p 1 -n 1 $( tput sgr0) "
echo " Will build MK3S multi language final GOLD firmware "
echo " with current commit count number and output extra information,"
echo " not delete lang build temporary files, keep Configuration_prusa.h and build with new fresh build folder."
echo
exit 6
fi
2021-05-03 18:01:48 +00:00
2021-06-17 18:59:35 +00:00
#Check if verbose_IDE is selected with argument '-j'
if [ ! -z " $verbose_IDE_flag " ] ; then
if [ $verbose_IDE_flag = = "1" ] ; then
verbose_IDE = "1"
elif [ $verbose_IDE_flag = = "0" ] ; then
verbose_IDE = "0"
else
echo "Only '0' and '1' are valid verbose_IDE values."
exit
fi
else
verbose_IDE = "0"
fi
2021-04-18 18:28:08 +00:00
#Check if Build is selected with argument '-f'
if [ ! -z " $board_flash_flag " ] ; then
2021-05-03 12:14:47 +00:00
if [ " $board_flash_flag " = = "256" ] ; then
2021-04-18 18:28:08 +00:00
BOARD_FLASH = "0x3FFFF"
BOARD_maximum_size = "253952"
2021-05-03 12:14:47 +00:00
echo " Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex) "
elif [ " $board_flash_flag " = = "384" ] ; then
2021-04-18 18:28:08 +00:00
BOARD_FLASH = "0x5FFFF"
BOARD_maximum_size = "385024"
2021-05-03 12:14:47 +00:00
echo " Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex) "
elif [ " $board_flash_flag " = = "512" ] ; then
2021-04-18 18:28:08 +00:00
BOARD_FLASH = "0x7FFFF"
BOARD_maximum_size = "516096"
2021-05-03 12:14:47 +00:00
echo " Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex) "
elif [ " $board_flash_flag " = = "1024" ] ; then
2021-04-18 18:28:08 +00:00
BOARD_FLASH = "0xFFFFF"
BOARD_maximum_size = "1040384"
2021-05-03 12:14:47 +00:00
echo " Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex) "
elif [ [ " $board_flash_flag " = = "32M" || " $board_flash_flag " = = "32768" ] ] ; then
2021-04-18 18:28:08 +00:00
BOARD_FLASH = "0x1FFFFFF"
BOARD_maximum_size = "33546240"
2021-05-03 12:14:47 +00:00
echo " Board flash size : 32 Mb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex) "
else
echo "Unsupported board flash size chosen. Only '256', '384', '512', '1024' and '32M' are allowed."
exit 7
fi
2021-04-18 18:28:08 +00:00
fi
#Check if Build is selected with argument '-x'
if [ ! -z " $board_mem_flag " ] ; then
2021-05-03 12:14:47 +00:00
if [ " $board_mem_flag " = = "8" ] ; then
2021-04-18 18:28:08 +00:00
BOARD_MEM = "0x21FF"
2021-05-03 12:14:47 +00:00
echo " Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex) "
2021-04-18 18:28:08 +00:00
elif [ " $board_mem_flag " = = "64" ] ; then
BOARD_MEM = "0xFFFF"
2021-05-03 12:14:47 +00:00
echo " Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex) "
else
echo "Unsupported board mem size chosen. Only '8', '64' are allowed."
exit 8
fi
2021-04-18 18:28:08 +00:00
fi
2019-07-17 11:51:34 +00:00
2021-05-03 18:01:48 +00:00
#Check if Arduino IDE version is correct
if [ ! -z " $IDE_flag " ] ; then
if [ [ " $IDE_flag " = = "1.8.5" || " $IDE_flag " = = "1.8.13" ] ] ; then
ARDUINO_ENV = " ${ IDE_flag } "
else
ARDUINO_ENV = "1.8.5"
fi
else
ARDUINO_ENV = "1.8.5"
fi
2019-07-17 11:51:34 +00:00
#### Set build environment
BUILD_ENV = "1.0.6"
2019-11-29 21:35:07 +00:00
BOARD = "prusa_einsy_rambo"
2019-12-17 13:05:39 +00:00
BOARD_PACKAGE_NAME = "PrusaResearch"
BOARD_VERSION = "1.0.3"
2021-04-18 18:28:08 +00:00
#BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
2019-07-26 08:32:14 +00:00
BOARD_URL = "https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
2019-11-29 21:35:07 +00:00
BOARD_FILENAME = "prusa3dboards"
2021-04-18 18:28:08 +00:00
#BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
2019-12-17 13:05:39 +00:00
BOARD_FILE_URL = "https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
#PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
PF_BUILD_FILE_URL = " https://github.com/prusa3d/PF-build-env/releases/download/ $BUILD_ENV -WinLin/PF-build-env-WinLin- $BUILD_ENV .zip "
2019-07-17 11:51:34 +00:00
LIB = "PrusaLibrary"
2019-02-16 05:05:43 +00:00
SCRIPT_PATH = " $( cd " $( dirname " $0 " ) " ; pwd -P ) "
# List few useful data
echo
2019-07-17 11:51:34 +00:00
echo "Script path :" $SCRIPT_PATH
echo "OS :" $OS
2019-07-23 22:10:32 +00:00
echo "OS type :" $TARGET_OS
2019-07-17 11:51:34 +00:00
echo ""
2021-01-08 10:01:17 +00:00
echo "Arduino IDE :" $ARDUINO_ENV
2019-07-17 11:51:34 +00:00
echo "Build env :" $BUILD_ENV
echo "Board :" $BOARD
2021-04-18 18:28:08 +00:00
if [ ! -z " $BOARD_FLASH " ] ; then
echo "Board flash :" $BOARD_FLASH
fi
if [ ! -z " $BOARD_MEM " ] ; then
echo "Board mem :" $BOARD_MEM
fi
2019-09-23 17:22:45 +00:00
echo "Package name:" $BOARD_PACKAGE_NAME
2019-12-17 13:05:39 +00:00
echo "Board v. :" $BOARD_VERSION
2019-07-17 11:51:34 +00:00
echo "Specific Lib:" $LIB
2019-02-16 05:05:43 +00:00
echo ""
2019-07-17 11:51:34 +00:00
#### Start prepare building environment
2019-02-16 05:05:43 +00:00
#Check if build exists and creates it if not
2019-07-23 22:10:32 +00:00
if [ ! -d "../PF-build-dl" ] ; then
2021-04-18 18:28:08 +00:00
mkdir ../PF-build-dl || exit 9
2019-02-16 05:05:43 +00:00
fi
2021-04-18 18:28:08 +00:00
cd ../PF-build-dl || exit 10
2019-07-17 11:51:34 +00:00
BUILD_ENV_PATH = " $( cd " $( dirname " $0 " ) " ; pwd -P ) "
2019-02-16 05:05:43 +00:00
# Check if PF-build-env-<version> exists and downloads + creates it if not
2019-07-18 05:17:35 +00:00
# The build environment is based on the supported Arduino IDE portable version with some changes
2019-02-16 05:05:43 +00:00
if [ ! -d " ../PF-build-env- $BUILD_ENV " ] ; then
2021-02-12 19:12:37 +00:00
echo " $( tput setaf 6) PF-build-env- $BUILD_ENV is missing ... creating it now for you $( tput sgr 0) "
mkdir ../PF-build-env-$BUILD_ENV
sleep 5
2019-02-16 05:05:43 +00:00
fi
2019-07-17 11:51:34 +00:00
# Download and extract supported Arduino IDE depending on OS
# Windows
2019-07-23 22:10:32 +00:00
if [ $TARGET_OS = = "windows" ] ; then
2021-04-29 17:23:52 +00:00
if [ ! -f " arduino- $ARDUINO_ENV -windows.zip " ] ; then
echo " $( tput setaf 6) Downloading Windows 32/64-bit Arduino IDE portable... $( tput setaf 2) "
sleep 2
wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV -windows.zip || exit 8
echo " $( tput sgr 0) "
fi
if [ [ ! -d " ../PF-build-env- $BUILD_ENV / $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor " && ! -e " ../PF-build-env- $BUILD_ENV /arduino- $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor .txt " ] ] ; then
echo " $( tput setaf 6) Unzipping Windows 32/64-bit Arduino IDE portable... $( tput setaf 2) "
sleep 2
2021-05-03 06:24:02 +00:00
unzip arduino-$ARDUINO_ENV -windows.zip -d ../PF-build-env-$BUILD_ENV || exit 9
2021-04-29 17:23:52 +00:00
mv ../PF-build-env-$BUILD_ENV /arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor
echo " # arduino- $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor " >> ../PF-build-env-$BUILD_ENV /arduino-$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor .txt
echo " $( tput sgr0) "
fi
2019-02-16 05:05:43 +00:00
fi
2019-07-17 11:51:34 +00:00
# Linux
2019-07-23 22:10:32 +00:00
if [ $TARGET_OS = = "linux" ] ; then
2019-07-17 11:51:34 +00:00
# 32 or 64 bit version
2021-02-12 19:12:37 +00:00
if [ ! -f " arduino- $ARDUINO_ENV -linux $Processor .tar.xz " ] ; then
echo " $( tput setaf 6) Downloading Linux $Processor Arduino IDE portable... $( tput setaf 2) "
sleep 2
wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV -linux$Processor .tar.xz || exit 8
echo " $( tput sgr 0) "
fi
if [ [ ! -d " ../PF-build-env- $BUILD_ENV / $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor " && ! -e " ../PF-build-env- $BUILD_ENV /arduino- $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor .txt " ] ] ; then
echo " $( tput setaf 6) Unzipping Linux $Processor Arduino IDE portable... $( tput setaf 2) "
sleep 2
2021-05-03 06:24:02 +00:00
tar -xvf arduino-$ARDUINO_ENV -linux$Processor .tar.xz -C ../PF-build-env-$BUILD_ENV / || exit 9
2021-02-12 19:12:37 +00:00
mv ../PF-build-env-$BUILD_ENV /arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor
echo " # arduino- $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor " >> ../PF-build-env-$BUILD_ENV /arduino-$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor .txt
echo " $( tput sgr0) "
fi
2019-02-16 05:05:43 +00:00
fi
2019-07-17 11:51:34 +00:00
# Make Arduino IDE portable
2019-10-17 12:05:51 +00:00
if [ ! -d ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor / ] ; then
2021-02-12 19:12:37 +00:00
mkdir ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /
2019-07-23 22:10:32 +00:00
fi
2019-10-17 12:05:51 +00:00
if [ ! -d ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/ ] ; then
2021-02-12 19:12:37 +00:00
mkdir ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable
2019-07-17 11:51:34 +00:00
fi
2019-10-17 12:05:51 +00:00
if [ ! -d ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/output/ ] ; then
2021-02-12 19:12:37 +00:00
mkdir ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/output
2019-07-17 11:51:34 +00:00
fi
2019-10-17 12:05:51 +00:00
if [ ! -d ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/packages/ ] ; then
2021-02-12 19:12:37 +00:00
mkdir ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/packages
2019-07-17 11:51:34 +00:00
fi
2019-10-17 12:05:51 +00:00
if [ ! -d ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/sketchbook/ ] ; then
2021-02-12 19:12:37 +00:00
mkdir ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/sketchbook
2019-07-17 11:51:34 +00:00
fi
2019-10-17 12:05:51 +00:00
if [ ! -d ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/sketchbook/libraries/ ] ; then
2021-02-12 19:12:37 +00:00
mkdir ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/sketchbook/libraries
2019-07-17 11:51:34 +00:00
fi
2019-10-17 12:05:51 +00:00
if [ ! -d ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/staging/ ] ; then
2021-02-12 19:12:37 +00:00
mkdir ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/staging
2019-07-17 11:51:34 +00:00
fi
# Change Arduino IDE preferences
2019-10-17 12:05:51 +00:00
if [ ! -e ../PF-build-env-$BUILD_ENV /Preferences-$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor .txt ] ; then
2021-02-12 19:12:37 +00:00
echo " $( tput setaf 6) Setting $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor Arduino IDE preferences for portable GUI usage... $( tput setaf 2) "
sleep 2
echo "update.check"
sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /lib/preferences.txt
echo "board"
sed -i " s/board = uno/board = $BOARD /g " ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /lib/preferences.txt
echo "editor.linenumbers"
sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /lib/preferences.txt
echo "boardsmanager.additional.urls"
echo " boardsmanager.additional.urls= $BOARD_URL " >>../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /lib/preferences.txt
echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /lib/preferences.txt
echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /lib/preferences.txt
echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /lib/preferences.txt
echo " # Preferences- $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor " >> ../PF-build-env-$BUILD_ENV /Preferences-$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor .txt
echo " $( tput sgr0) "
2019-07-17 11:51:34 +00:00
fi
# Download and extract Prusa Firmware related parts
# Download and extract PrusaResearchRambo board
if [ ! -f " $BOARD_FILENAME - $BOARD_VERSION .tar.bz2 " ] ; then
2021-02-12 19:12:37 +00:00
echo " $( tput setaf 6) Downloading Prusa Research AVR MK3 RAMBo EINSy build environment... $( tput setaf 2) "
sleep 2
2021-05-03 06:24:02 +00:00
wget $BOARD_FILE_URL || exit 10
2019-07-17 11:51:34 +00:00
fi
2019-10-17 12:05:51 +00:00
if [ [ ! -d " ../PF-build-env- $BUILD_ENV / $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor /portable/packages/ $BOARD_PACKAGE_NAME /hardware/avr/ $BOARD_VERSION " || ! -e " ../PF-build-env- $BUILD_ENV / $BOARD_FILENAME - $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor .txt " ] ] ; then
2021-02-12 19:12:37 +00:00
echo " $( tput setaf 6) Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable... $( tput setaf 2) "
sleep 2
2021-05-03 06:24:02 +00:00
tar -xvf $BOARD_FILENAME -$BOARD_VERSION .tar.bz2 -C ../PF-build-env-$BUILD_ENV / || exit 11
2021-02-12 19:12:37 +00:00
if [ ! -d ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/packages/$BOARD_PACKAGE_NAME ] ; then
mkdir ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/packages/$BOARD_PACKAGE_NAME
fi
if [ ! -d ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/packages/$BOARD_PACKAGE_NAME ] ; then
mkdir ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/packages/$BOARD_PACKAGE_NAME
fi
if [ ! -d ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/packages/$BOARD_PACKAGE_NAME /hardware ] ; then
mkdir ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/packages/$BOARD_PACKAGE_NAME /hardware
fi
if [ ! -d ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/packages/$BOARD_PACKAGE_NAME /hardware/avr ] ; then
mkdir ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/packages/$BOARD_PACKAGE_NAME /hardware/avr
fi
mv ../PF-build-env-$BUILD_ENV /$BOARD_FILENAME -$BOARD_VERSION ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/packages/$BOARD_PACKAGE_NAME /hardware/avr/$BOARD_VERSION
echo " # $BOARD_FILENAME - $BOARD_VERSION " >> ../PF-build-env-$BUILD_ENV /$BOARD_FILENAME -$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor .txt
echo " $( tput sgr 0) "
fi
2019-07-17 11:51:34 +00:00
# Download and extract Prusa Firmware specific library files
2019-12-15 16:27:15 +00:00
if [ ! -f " PF-build-env-WinLin- $BUILD_ENV .zip " ] ; then
2021-02-12 19:12:37 +00:00
echo " $( tput setaf 6) Downloading Prusa Firmware build environment... $( tput setaf 2) "
sleep 2
2021-05-03 06:24:02 +00:00
wget $PF_BUILD_FILE_URL || exit 12
2021-02-12 19:12:37 +00:00
echo " $( tput sgr 0) "
2019-07-17 11:51:34 +00:00
fi
2019-10-17 12:05:51 +00:00
if [ ! -e " ../PF-build-env- $BUILD_ENV /PF-build-env- $BUILD_ENV - $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor .txt " ] ; then
2021-02-12 19:12:37 +00:00
echo " $( tput setaf 6) Unzipping Prusa Firmware build environment... $( tput setaf 2) "
sleep 2
2021-05-03 06:24:02 +00:00
unzip -o PF-build-env-WinLin-$BUILD_ENV .zip -d ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor || exit 13
2021-02-12 19:12:37 +00:00
echo " # PF-build-env- $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor - $BUILD_ENV " >> ../PF-build-env-$BUILD_ENV /PF-build-env-$BUILD_ENV -$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor .txt
echo " $( tput sgr0) "
2019-07-17 11:51:34 +00:00
fi
2019-07-22 13:49:15 +00:00
# Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
2019-10-17 12:05:51 +00:00
if [ -d " ../PF-build-env- $BUILD_ENV / $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor /portable/packages/arduino/tools " ] ; then
2021-02-12 19:12:37 +00:00
echo " $( tput setaf 6) Arduino IDE boards / tools have been manually updated... $"
echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
sleep 2
fi
2019-10-17 12:05:51 +00:00
if [ -d " ../PF-build-env- $BUILD_ENV / $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor /portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2 " ] ; then
2021-02-12 19:12:37 +00:00
echo " $( tput setaf 6) PrusaReasearch compatible tools have been manually updated... $( tput setaf 2) "
sleep 2
echo " $( tput setaf 6) Copying Prusa Firmware build environment to manually updated boards / tools... $( tput setaf 2) "
sleep 2
cp -f ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor /portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
echo " # PF-build-env-portable- $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor - $BUILD_ENV " >> ../PF-build-env-$BUILD_ENV /PF-build-env-portable-$BUILD_ENV -$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor .txt
echo " $( tput sgr0) "
fi
2019-10-17 12:05:51 +00:00
if [ -d " ../PF-build-env- $BUILD_ENV / $ARDUINO_ENV - $BOARD_VERSION - $TARGET_OS - $Processor /portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2 " ] ; then
2021-02-12 19:12:37 +00:00
echo " $( tput setaf 1) Arduino IDE tools have been updated manually to a non supported version!!! "
echo " Delete ../PF-build-env- $BUILD_ENV and start the script again "
echo " Script will not continue until this have been fixed $( tput setaf 2) "
sleep 2
echo " $( tput sgr0) "
2021-05-03 06:24:02 +00:00
exit 14
2019-07-22 13:49:15 +00:00
fi
2019-07-17 11:51:34 +00:00
#### End prepare building
#### Start
2019-02-16 05:05:43 +00:00
cd $SCRIPT_PATH
2021-01-08 10:01:17 +00:00
# Check if git is available
2020-11-02 13:54:16 +00:00
if type git > /dev/null; then
2021-02-12 19:12:37 +00:00
git_available = "1"
fi
2020-11-02 13:54:16 +00:00
#
# '-v' argument defines which variant of the Prusa Firmware will be compiled
if [ -z " $variant_flag " ] ; then
2021-02-12 19:12:37 +00:00
# Select which variant of the Prusa Firmware will be compiled, like
PS3 = "Select a variant: "
while IFS = read -r -d $'\0' f; do
options[ i++] = " $f "
done < <( find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
select opt in " ${ options [@] } " "All" "Quit" ; do
case $opt in
*.h)
VARIANT = $( basename " $opt " ".h" )
VARIANTS[ i++] = " $opt "
break
; ;
"All" )
VARIANT = "All"
VARIANTS = ${ options [*] }
break
; ;
"Quit" )
echo "You chose to stop"
2021-05-03 06:24:02 +00:00
exit 22
2021-02-12 19:12:37 +00:00
; ;
*)
echo " $( tput setaf 1) This is not a valid variant $( tput sgr0) "
; ;
esac
done
2019-02-16 05:05:43 +00:00
else
2021-02-12 19:12:37 +00:00
if [ -f " $SCRIPT_PATH /Firmware/variants/ $variant_flag " ] ; then
VARIANTS = $variant_flag
elif [ " $variant_flag " = = "All" ] ; then
while IFS = read -r -d $'\0' f; do
options[ i++] = " $f "
done < <( find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
VARIANT = "All"
VARIANTS = ${ options [*] }
else
echo " $( tput setaf 1) Argument $variant_flag could not be found in Firmware/variants please choose a valid one. $( tput sgr0) "
echo " Only $( tput setaf 2) 'All' $( tput sgr0) and file names below are allowed as variant '-v' argument. $( tput setaf 2) "
ls -1 $SCRIPT_PATH /Firmware/variants/*.h | xargs -n1 basename
echo " $( tput sgr0) "
2021-05-03 06:24:02 +00:00
exit 23
2021-02-12 19:12:37 +00:00
fi
2019-02-16 05:05:43 +00:00
fi
2021-01-08 10:01:17 +00:00
#'-l' argument defines if it is an English only version. Known values EN_ONLY / ALL
2019-02-16 05:05:43 +00:00
#Check default language mode
MULTI_LANGUAGE_CHECK = $( grep --max-count= 1 "^#define LANG_MODE *" $SCRIPT_PATH /Firmware/config.h| sed -e's/ */ /g' | cut -d ' ' -f3)
2020-11-02 13:54:16 +00:00
if [ -z " $language_flag " ] ; then
2021-02-12 19:12:37 +00:00
PS3 = "Select a language: "
echo
echo "Which lang-build do you want?"
select yn in "Multi languages" "English only" ; do
case $yn in
"Multi languages" )
LANGUAGES = "ALL"
break
; ;
"English only" )
LANGUAGES = "EN_ONLY"
break
; ;
*)
echo " $( tput setaf 1) This is not a valid language $( tput sgr0) "
; ;
esac
done
2019-02-16 05:05:43 +00:00
else
2021-02-12 19:12:37 +00:00
if [ [ " $language_flag " = = "ALL" || " $language_flag " = = "EN_ONLY" ] ] ; then
LANGUAGES = $language_flag
else
echo " $( tput setaf 1) Language argument is wrong! $( tput sgr0) "
echo " Only $( tput setaf 2) 'ALL' $( tput sgr0) or $( tput setaf 2) 'EN_ONLY' $( tput sgr0) are allowed as language '-l' argument! "
2021-05-03 06:24:02 +00:00
exit 24
2021-02-12 19:12:37 +00:00
fi
2019-02-16 07:04:45 +00:00
fi
2020-11-02 13:54:16 +00:00
#Check if DEV_STATUS is selected via argument '-d'
if [ ! -z " $devel_flag " ] ; then
2021-02-12 19:12:37 +00:00
if [ [ " $devel_flag " = = "GOLD" || " $devel_flag " = = "RC" || " $devel_flag " = = "BETA" || " $devel_flag " = = "ALPHA" || " $devel_flag " = = "DEVEL" || " $devel_flag " = = "DEBUG" || " $devel_flag " = = "UNKNOWN" ] ] ; then
DEV_STATUS_SELECTED = $devel_flag
2021-05-03 12:11:03 +00:00
elif [ [ " $devel_flag " = = "atmega404" || " $devel_flag " = = "atmega404_no_bootloader" ] ] ; then
MK404_DEBUG = $devel_flag
2021-02-12 19:12:37 +00:00
else
echo " $( tput setaf 1) Development argument is wrong! $( tput sgr0) "
echo " Only $( tput setaf 2) 'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $( tput sgr0) are allowed as devel '-d' argument! $( tput sgr0) "
2021-05-03 06:24:02 +00:00
exit 25
2021-02-12 19:12:37 +00:00
fi
2019-02-16 05:05:43 +00:00
fi
2020-11-02 13:54:16 +00:00
#Check if Build is selected via argument '-b'
if [ ! -z " $build_flag " ] ; then
2021-02-12 19:12:37 +00:00
if [ [ " $build_flag " = = "Auto" && " $git_available " = = "1" ] ] ; then
echo " Build changed to $build_flag "
BUILD = $( git rev-list --count HEAD)
elif [ [ $build_flag = ~ ^[ 0-9] +$ ] ] ; then
BUILD = $build_flag
else
echo " $( tput setaf 1) Build number argument is wrong! $( tput sgr0) "
echo " Only $( tput setaf 2) 'Auto' (git needed) or numbers $( tput sgr0) are allowed as build '-b' argument! $( tput sgr0) "
2021-05-03 06:24:02 +00:00
exit 26
2021-02-12 19:12:37 +00:00
fi
echo " New Build number is: $BUILD "
2020-11-02 13:54:16 +00:00
fi
2020-10-05 11:18:18 +00:00
# check if script has been started with arguments
2020-11-02 13:54:16 +00:00
if [ [ " $# " -eq "0" || " $output_flag " = = 1 ] ] ; then
2021-02-12 19:12:37 +00:00
OUTPUT = 1
2020-10-05 11:18:18 +00:00
else
2021-02-12 19:12:37 +00:00
OUTPUT = 0
2020-10-05 11:18:18 +00:00
fi
#echo "Output is:" $OUTPUT
2020-10-05 13:25:54 +00:00
#Check git branch has changed
2021-01-08 10:01:17 +00:00
if [ ! -z "git_available" ] ; then
2021-02-12 19:12:37 +00:00
BRANCH = ""
CLEAN_PF_FW_BUILD = 0
2020-10-05 13:25:54 +00:00
else
2021-02-12 19:12:37 +00:00
BRANCH = $( git branch --show-current)
echo "Current branch is:" $BRANCH
if [ ! -f " $SCRIPT_PATH /../PF-build.branch " ] ; then
echo " $BRANCH " >| $SCRIPT_PATH /../PF-build.branch
echo "created PF-build.branch file"
else
PRE_BRANCH = $( cat " $SCRIPT_PATH /../PF-build.branch " )
echo "Previous branch was:" $PRE_BRANCH
if [ ! " $BRANCH " = = " $PRE_BRANCH " ] ; then
CLEAN_PF_FW_BUILD = 1
echo " $BRANCH " >| $SCRIPT_PATH /../PF-build.branch
fi
fi
2020-10-05 13:25:54 +00:00
fi
2019-02-16 05:05:43 +00:00
#Set BUILD_ENV_PATH
2021-05-03 06:24:02 +00:00
cd ../PF-build-env-$BUILD_ENV /$ARDUINO_ENV -$BOARD_VERSION -$TARGET_OS -$Processor || exit 27
2019-02-16 05:05:43 +00:00
BUILD_ENV_PATH = " $( pwd -P ) "
cd ../..
2019-04-05 21:53:33 +00:00
#Checkif BUILD_PATH exists and if not creates it
2019-02-16 05:05:43 +00:00
if [ ! -d "Prusa-Firmware-build" ] ; then
2021-05-03 06:24:02 +00:00
mkdir Prusa-Firmware-build || exit 28
2019-02-16 05:05:43 +00:00
fi
#Set the BUILD_PATH for Arduino IDE
2021-05-03 06:24:02 +00:00
cd Prusa-Firmware-build || exit 29
2019-02-16 05:05:43 +00:00
BUILD_PATH = " $( pwd -P ) "
2020-10-05 13:25:54 +00:00
#Check git branch has changed
if [ " $CLEAN_PF_FW_BUILD " = = "1" ] ; then
2021-02-12 19:12:37 +00:00
read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
rm -r *
2020-10-05 13:25:54 +00:00
else
2021-02-12 19:12:37 +00:00
echo "Nothing to clean up"
2020-10-05 13:25:54 +00:00
fi
2019-02-16 05:05:43 +00:00
for v in ${ VARIANTS [*] }
do
2021-02-12 19:12:37 +00:00
VARIANT = $( basename " $v " ".h" )
2021-05-03 12:11:03 +00:00
MK404_PRINTER = $( grep --max-count= 1 "\bPRINTER_TYPE\b" $SCRIPT_PATH /Firmware/variants/$VARIANT .h | sed -e's/ */ /g' | cut -d ' ' -f3 | cut -d '_' -f2)
2021-02-12 19:12:37 +00:00
# Find firmware version in Configuration.h file and use it to generate the hex filename
2021-06-17 17:08:55 +00:00
FW_MAJOR = $( grep --max-count= 1 "\bFW_MAJOR\b" $SCRIPT_PATH /Firmware/Configuration.h | sed -e's/ */ /g' | cut -d ' ' -f3)
FW_MINOR = $( grep --max-count= 1 "\bFW_MINOR\b" $SCRIPT_PATH /Firmware/Configuration.h | sed -e's/ */ /g' | cut -d ' ' -f3)
FW_REVISION = $( grep --max-count= 1 "\bFW_REVISION\b" $SCRIPT_PATH /Firmware/Configuration.h| sed -e's/ */ /g' | cut -d ' ' -f3)
FW = " $FW_MAJOR $FW_MINOR $FW_REVISION "
#FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
2021-02-12 19:12:37 +00:00
if [ -z " $BUILD " ] ; then
# Find build version in Configuration.h file and use it to generate the hex filename
BUILD = $( grep --max-count= 1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH /Firmware/Configuration.h | sed -e's/ */ /g' | cut -d ' ' -f3)
else
# Find and replace build version in Configuration.h file
BUILD_ORG = $( grep --max-count= 1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH /Firmware/Configuration.h | sed -e's/ */ /g' | cut -d ' ' -f3)
echo " Original build number: $BUILD_ORG "
sed -i -- " s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD /g " $SCRIPT_PATH /Firmware/Configuration.h
fi
# Check if the motherboard is an EINSY and if so only one hex file will generated
MOTHERBOARD = $( grep --max-count= 1 "\bMOTHERBOARD\b" $SCRIPT_PATH /Firmware/variants/$VARIANT .h | sed -e's/ */ /g' | cut -d ' ' -f3)
# Check development status
2021-06-17 17:08:55 +00:00
FW_FLAV = $( grep --max-count= 1 "//#define FW_FLAVOR\b" $SCRIPT_PATH /Firmware/Configuration.h| cut -d ' ' -f1)
if [ [ " $FW_FLAV " != "//#define" ] ] ; then
FW_FLAVOR = $( grep --max-count= 1 "\bFW_FLAVOR\b" $SCRIPT_PATH /Firmware/Configuration.h| sed -e's/ */ /g' | cut -d ' ' -f3)
FW_FLAVERSION = $( grep --max-count= 1 "\bFW_FLAVERSION\b" $SCRIPT_PATH /Firmware/Configuration.h| sed -e's/ */ /g' | cut -d ' ' -f3)
if [ [ " $FW_FLAVOR " != "//#define FW_FLAVOR" ] ] ; then
FW = " $FW - $FW_FLAVOR "
DEV_CHECK = " $FW_FLAVOR "
if [ ! -z " $FW_FLAVERSION " ] ; then
FW = " $FW $FW_FLAVERSION "
fi
fi
fi
2021-02-12 19:12:37 +00:00
DEV_CHECK = $( grep --max-count= 1 "\bFW_VERSION\b" $SCRIPT_PATH /Firmware/Configuration.h | sed -e's/ */ /g' | cut -d '"' -f2| sed 's/\.//g' | cut -d '-' -f2)
if [ -z " $DEV_STATUS_SELECTED " ] ; then
if [ [ " $DEV_CHECK " = = *"RC" * ] ] ; then
DEV_STATUS = "RC"
2021-06-17 17:08:55 +00:00
elif [ [ " $DEV_CHECK " = = *"ALPHA" * ] ] ; then
2021-02-12 19:12:37 +00:00
DEV_STATUS = "ALPHA"
2021-06-17 17:08:55 +00:00
elif [ [ " $DEV_CHECK " = = *"BETA" * ] ] ; then
2021-02-12 19:12:37 +00:00
DEV_STATUS = "BETA"
elif [ [ " $DEV_CHECK " = = "DEVEL" ] ] ; then
DEV_STATUS = "DEVEL"
elif [ [ " $DEV_CHECK " = = "DEBUG" ] ] ; then
DEV_STATUS = "DEBUG"
else
DEV_STATUS = "UNKNOWN"
echo
echo " $( tput setaf 5) DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD? $( tput sgr0) "
PS3 = "Select YES only if source code is tested and trusted: "
select yn in "Yes" "No" ; do
case $yn in
Yes)
DEV_STATUS = "GOLD"
DEV_STATUS_SELECTED = "GOLD"
break
; ;
2021-05-03 12:14:47 +00:00
No)
2021-02-12 19:12:37 +00:00
DEV_STATUS = "UNKNOWN"
DEV_STATUS_SELECTED = "UNKNOWN"
break
; ;
*)
echo " $( tput setaf 1) This is not a valid DEV_STATUS $( tput sgr0) "
; ;
esac
done
fi
else
DEV_STATUS = $DEV_STATUS_SELECTED
fi
#Prepare hex files folders
if [ ! -d " $SCRIPT_PATH /../PF-build-hex/FW $FW -Build $BUILD / $MOTHERBOARD " ] ; then
2021-05-03 12:14:47 +00:00
mkdir -p $SCRIPT_PATH /../PF-build-hex/FW$FW -Build$BUILD /$MOTHERBOARD || exit 28
2021-02-12 19:12:37 +00:00
fi
OUTPUT_FOLDER = " PF-build-hex/FW $FW -Build $BUILD / $MOTHERBOARD "
2021-04-18 18:28:08 +00:00
if [ " $BOARD " != "prusa_einsy_rambo" ] ; then
2021-05-03 12:14:47 +00:00
if [ ! -d " $SCRIPT_PATH /../PF-build-hex/FW $FW -Build $BUILD / $BOARD " ] ; then
mkdir -p $SCRIPT_PATH /../PF-build-hex/FW$FW -Build$BUILD /$BOARD || exit 28
fi
2021-04-18 18:28:08 +00:00
OUTPUT_FOLDER = " PF-build-hex/FW $FW -Build $BUILD / $BOARD "
fi
2021-02-12 19:12:37 +00:00
#Check if exactly the same hexfile already exists
if [ [ -f " $SCRIPT_PATH /../ $OUTPUT_FOLDER /FW $FW -Build $BUILD - $VARIANT .hex " && " $LANGUAGES " = = "ALL" ] ] ; then
echo ""
ls -1 $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT .hex | xargs -n1 basename
echo " $( tput setaf 6) This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file. $( tput sgr 0) "
if [ $OUTPUT = = "1" ] ; then
read -t 10 -p "Press Enter to continue..."
fi
elif [ [ -f " $SCRIPT_PATH /../ $OUTPUT_FOLDER /FW $FW -Build $BUILD - $VARIANT -EN_ONLY.hex " && " $LANGUAGES " = = "EN_ONLY" ] ] ; then
echo ""
ls -1 $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT -EN_ONLY.hex | xargs -n1 basename
echo " $( tput setaf 6) This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file. $( tput sgr 0) "
if [ $OUTPUT = = "1" ] ; then
read -t 10 -p "Press Enter to continue..."
fi
fi
if [ [ -f " $SCRIPT_PATH /../ $OUTPUT_FOLDER /FW $FW -Build $BUILD - $VARIANT .zip " && " $LANGUAGES " = = "ALL" ] ] ; then
echo ""
ls -1 $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT .zip | xargs -n1 basename
echo " $( tput setaf 6) This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file. $( tput sgr 0) "
if [ $OUTPUT = = "1" ] ; then
read -t 10 -p "Press Enter to continue..."
fi
fi
#List some useful data
echo " $( tput setaf 2) $( tput setab 7) "
2021-05-03 18:01:48 +00:00
echo "Printer :" $MK404_PRINTER
2021-02-12 19:12:37 +00:00
echo "Variant :" $VARIANT
echo "Firmware :" $FW
echo "Build # :" $BUILD
echo "Dev Check :" $DEV_CHECK
echo "DEV Status :" $DEV_STATUS
echo "Motherboard:" $MOTHERBOARD
2021-04-18 18:28:08 +00:00
echo "Board flash:" $BOARD_FLASH
echo "Board mem :" $BOARD_MEM
2021-02-12 19:12:37 +00:00
echo "Languages :" $LANGUAGES
echo "Hex-file Folder:" $OUTPUT_FOLDER
echo " $( tput sgr0) "
#Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
if [ ! -f " $SCRIPT_PATH /Firmware/Configuration_prusa.h " ] ; then
2021-05-03 06:24:02 +00:00
cp -f $SCRIPT_PATH /Firmware/variants/$VARIANT .h $SCRIPT_PATH /Firmware/Configuration_prusa.h || exit 31
2021-02-12 19:12:37 +00:00
else
echo " $( tput setaf 6) Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant. $( tput sgr 0) "
if [ $OUTPUT = = "1" ] ; then
read -t 10 -p "Press Enter to continue..."
fi
2021-05-03 06:24:02 +00:00
cp -f $SCRIPT_PATH /Firmware/variants/$VARIANT .h $SCRIPT_PATH /Firmware/Configuration_prusa.h || exit 31
2021-02-12 19:12:37 +00:00
fi
#Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
sed -i -- " s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_ $DEV_STATUS /g " $SCRIPT_PATH /Firmware/Configuration.h
# set FW_REPOSITORY
sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH /Firmware/Configuration.h
#Prepare English only or multi-language version to be build
if [ $LANGUAGES = = "EN_ONLY" ] ; then
echo " "
echo "English only language firmware will be built"
sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH /Firmware/config.h
echo " "
else
echo " "
echo "Multi-language firmware will be built"
sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH /Firmware/config.h
echo " "
fi
#Check if compiler flags are set to Prusa specific needs for the rambo board.
2021-03-17 17:33:54 +00:00
#if [ $TARGET_OS == "windows" ]; then
#RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
#fi
2021-05-03 06:24:02 +00:00
#New fresh PF-Firmware-build
if [ " $new_build_flag " = = "1" ] ; then
rm -r -f $BUILD_PATH /* || exit 54
fi
2021-04-18 18:28:08 +00:00
# Prepare Board mem and flash modifications
## Check board mem size
CURRENT_BOARD_MEM = $( grep "#define RAMEND" $BUILD_ENV_PATH /hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g' | cut -d ' ' -f3| tr -d $'\n' )
if [ $CURRENT_BOARD_MEM != "0x21FF" ] ; then
echo "Board mem has been already modified or not reset"
echo "Current:" $CURRENT_BOARD_MEM
2021-05-05 18:05:35 +00:00
PS3 = " Select $( tput setaf 2) Yes $( tput sgr 0) if you want to reset it. "
2021-04-18 18:28:08 +00:00
select yn in "Yes" "No" ; do
case $yn in
Yes)
echo "Resetting board mem size"
sed -i -- " s/^#define RAMEND .* $/#define RAMEND 0x21FF/g " $BUILD_ENV_PATH /hardware/tools/avr/avr/include/avr/iom2560.h
break
; ;
*)
echo "Continuing with modified mem size"
break
; ;
esac
done
fi
## Modify board mem size
if [ [ ! -z $BOARD_MEM && " $BOARD_MEM " != "0x21FF" ] ] ; then
2021-05-03 18:01:48 +00:00
echo " $( tput setaf 3) Modifying board memory size (hex): $( tput sgr 0) "
2021-04-18 18:28:08 +00:00
echo "Old:" $CURRENT_BOARD_MEM
echo "New:" $BOARD_MEM
2021-05-03 18:01:48 +00:00
read -t 5 -p " To cancel press $( tput setaf 1) CRTL+C $( tput sgr 0) "
echo ""
2021-04-18 18:28:08 +00:00
sed -i -- " s/^#define RAMEND 0x21FF/#define RAMEND ${ BOARD_MEM } /g " $BUILD_ENV_PATH /hardware/tools/avr/avr/include/avr/iom2560.h
fi
2021-05-03 06:24:02 +00:00
2021-04-18 18:28:08 +00:00
## Check board flash size
CURRENT_BOARD_FLASH = $( grep "#define FLASHEND" $BUILD_ENV_PATH /hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g' | cut -d ' ' -f3| tr -d $'\n' )
CURRENT_BOARD_maximum_size = $( grep "prusa_einsy_rambo.upload.maximum_size" $BUILD_ENV_PATH /portable/packages/$BOARD_PACKAGE_NAME /hardware/avr/$BOARD_VERSION /boards.txt | cut -d '=' -f2| tr -d $'\n' )
if [ [ $CURRENT_BOARD_FLASH != "0x3FFFF" || $CURRENT_BOARD_maximum_size != "253952" ] ] ; then
echo "Board flash has been already modified or not reset"
echo "Current flash size:" $CURRENT_BOARD_FLASH
echo "Current max. size:" $CURRENT_BOARD_maximum_size
2021-05-05 18:05:35 +00:00
PS3 = " Select $( tput setaf 2) Yes $( tput sgr 0) if you want to reset it. "
2021-04-18 18:28:08 +00:00
select yn in "Yes" "No" ; do
case $yn in
Yes)
2021-05-03 18:01:48 +00:00
echo " $( tput setaf 1) Resetting board flash size $( tput sgr 0) "
2021-04-18 18:28:08 +00:00
sed -i -- " s/^#define FLASHEND .* $/#define FLASHEND 0x3FFFF/g " $BUILD_ENV_PATH /hardware/tools/avr/avr/include/avr/iom2560.h
sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH /portable/packages/$BOARD_PACKAGE_NAME /hardware/avr/$BOARD_VERSION /boards.txt
break
; ;
*)
2021-05-03 18:01:48 +00:00
echo " $( tput setaf 3) Continuing with modified flash size $( tput sgr 0) "
2021-04-18 18:28:08 +00:00
break
; ;
esac
done
fi
## Modify boad flash size
if [ [ ! -z $BOARD_FLASH && " $BOARD_FLASH " != "0x3FFFF" ] ] ; then
echo "Modifying board flash size (hex):"
echo "Old flash size:" $CURRENT_BOARD_FLASH
echo "New flash size:" $BOARD_FLASH
echo "Old max. size:" $CURRENT_BOARD_maximum_size
echo "New max. size:" $BOARD_maximum_size
2021-05-03 18:01:48 +00:00
read -t 5 -p " To cancel press $( tput setaf 1) CRTL+C $( tput sgr 0) "
2021-04-18 18:28:08 +00:00
sed -i -- " s/^#define FLASHEND .*/#define FLASHEND ${ BOARD_FLASH } /g " $BUILD_ENV_PATH /hardware/tools/avr/avr/include/avr/iom2560.h
sed -i -- " s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size= ${ BOARD_maximum_size } /g " $BUILD_ENV_PATH /portable/packages/$BOARD_PACKAGE_NAME /hardware/avr/$BOARD_VERSION /boards.txt
fi
2021-05-03 06:24:02 +00:00
2021-05-03 12:14:47 +00:00
#Check if compiler flags are set to Prusa specific needs for the rambo board.
# if [ $TARGET_OS == "windows" ]; then
# RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
# fi
#### End of Prepare building
#### Start building
2021-02-12 19:12:37 +00:00
export ARDUINO = $BUILD_ENV_PATH
#echo $BUILD_ENV_PATH
#export BUILDER=$ARDUINO/arduino-builder
echo
#read -t 5 -p "Press Enter..."
echo
echo "Start to build Prusa Firmware ..."
echo " Using variant $VARIANT $( tput setaf 3) "
if [ $OUTPUT = = "1" ] ; then
sleep 2
fi
2021-06-17 18:59:35 +00:00
if [ $verbose_IDE = = "1" ] ; then
$BUILD_ENV_PATH /arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO /hardware -hardware $ARDUINO /portable/packages -tools $ARDUINO /tools-builder -tools $ARDUINO /hardware/tools/avr -tools $ARDUINO /portable/packages -built-in-libraries $ARDUINO /libraries -libraries $ARDUINO /portable/sketchbook/libraries -fqbn= $BOARD_PACKAGE_NAME :avr:$BOARD -build-path= $BUILD_PATH -warnings= all $SCRIPT_PATH /Firmware/Firmware.ino || exit 41
fi
$BUILD_ENV_PATH /arduino-builder -compile -hardware $ARDUINO /hardware -hardware $ARDUINO /portable/packages -tools $ARDUINO /tools-builder -tools $ARDUINO /hardware/tools/avr -tools $ARDUINO /portable/packages -built-in-libraries $ARDUINO /libraries -libraries $ARDUINO /portable/sketchbook/libraries -fqbn= $BOARD_PACKAGE_NAME :avr:$BOARD -build-path= $BUILD_PATH -warnings= all -verbose= $verbose_IDE $SCRIPT_PATH /Firmware/Firmware.ino || exit 42
2021-02-12 19:12:37 +00:00
echo " $( tput sgr 0) "
if [ $LANGUAGES = = "ALL" ] ; then
echo " $( tput setaf 2) "
echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
echo " $( tput sgr 0) "
if [ $OUTPUT = = "1" ] ; then
sleep 2
fi
cd $SCRIPT_PATH /lang
echo " $( tput setaf 3) "
2021-05-03 06:24:02 +00:00
./config.sh || exit 43
2021-02-12 19:12:37 +00:00
echo " $( tput sgr 0) "
# Check if previous languages and firmware build exist and if so clean them up
if [ -f "lang_en.tmp" ] ; then
echo ""
echo " $( tput setaf 6) Previous lang build files already exist these will be cleaned up in 10 seconds. $( tput sgr 0) "
if [ $OUTPUT = = "1" ] ; then
read -t 10 -p "Press Enter to continue..."
fi
echo " $( tput setaf 3) "
./lang-clean.sh
echo " $( tput sgr 0) "
fi
if [ -f "progmem.out" ] ; then
echo ""
echo " $( tput setaf 6) Previous firmware build files already exist these will be cleaned up in 10 seconds. $( tput sgr 0) "
if [ $OUTPUT = = "1" ] ; then
read -t 10 -p "Press Enter to continue..."
fi
echo " $( tput setaf 3) "
./fw-clean.sh
echo " $( tput sgr 0) "
fi
# build languages
echo " $( tput setaf 3) "
2021-05-03 06:24:02 +00:00
./lang-build.sh || exit 44
2021-03-17 17:33:54 +00:00
# build community languages
2021-05-03 06:24:02 +00:00
./lang-community.sh || exit 45
2021-02-12 19:12:37 +00:00
# Combine compiled firmware with languages
2021-05-03 06:24:02 +00:00
./fw-build.sh || exit 46
2021-02-12 19:12:37 +00:00
cp not_tran.txt not_tran_$VARIANT .txt
cp not_used.txt not_used_$VARIANT .txt
echo " $( tput sgr 0) "
# Check if the motherboard is an EINSY and if so only one hex file will generated
MOTHERBOARD = $( grep --max-count= 1 "\bMOTHERBOARD\b" $SCRIPT_PATH /Firmware/variants/$VARIANT .h | sed -e's/ */ /g' | cut -d ' ' -f3)
# If the motherboard is an EINSY just copy one hexfile
if [ " $MOTHERBOARD " = "BOARD_EINSY_1_0a" ] ; then
echo " $( tput setaf 2) Copying multi language firmware for MK3/Einsy board to PF-build-hex folder $( tput sgr 0) "
2021-02-13 09:35:34 +00:00
# Make a copy of "lang.bin" for MK404 MK3 and MK3S
2021-04-23 18:09:20 +00:00
if [ ! -z " $mk404_flag " ] ; then
cp -f lang.bin $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT -lang.bin
fi
2021-02-13 09:35:34 +00:00
# End of "lang.bin" for MK3 and MK3S copy
2021-02-12 19:12:37 +00:00
cp -f firmware.hex $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT .hex
2021-06-17 18:59:35 +00:00
cp -f $BUILD_PATH /Firmware.ino.elf $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT .elf
2021-02-12 19:12:37 +00:00
else
echo " $( tput setaf 2) Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder $( tput sgr 0) "
cp -f firmware_cz.hex $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT -cz.hex
cp -f firmware_de.hex $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT -de.hex
cp -f firmware_es.hex $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT -es.hex
cp -f firmware_fr.hex $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT -fr.hex
cp -f firmware_it.hex $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT -it.hex
cp -f firmware_pl.hex $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT -pl.hex
2021-05-03 12:14:47 +00:00
cp -f firmware_nl.hex $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT -nl.hex
2021-06-17 18:59:35 +00:00
cp -f $BUILD_PATH /Firmware.ino.elf $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT .elf
2021-02-12 19:12:37 +00:00
if [ $TARGET_OS = = "windows" ] ; then
zip a $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT .zip $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT -??.hex
rm $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT -??.hex
elif [ $TARGET_OS = = "linux" ] ; then
2021-02-13 09:35:34 +00:00
# Make a copy for MK404 sim of MK2, MK2.5, MK2.5S firmware
2021-02-12 19:12:37 +00:00
if [ ! -z " $mk404_flag " ] ; then
cp -f firmware_de.hex $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT .hex
fi
2021-02-13 09:35:34 +00:00
# End of MK2, MK2.5, MK2.5S firmware copy
2021-02-12 19:12:37 +00:00
zip -m -j ../../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT .zip ../../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT -??.hex
fi
fi
2021-05-03 06:24:02 +00:00
# Cleanup after build
if [ [ -z " $clean_flag " || " $clean_flag " = = "0" ] ] ; then
echo " $( tput setaf 3) "
./fw-clean.sh || exit 51
./lang-clean.sh || exit 52
echo " $( tput sgr 0) "
fi
2021-02-12 19:12:37 +00:00
else
echo " $( tput setaf 2) Copying English only firmware to PF-build-hex folder $( tput sgr 0) "
2021-05-03 06:24:02 +00:00
cp -f $BUILD_PATH /Firmware.ino.hex $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT -EN_ONLY.hex || exit 47
2021-06-17 18:59:35 +00:00
echo " $( tput setaf 2) Copying English only elf file to PF-build-hex folder $( tput sgr 0) "
cp -f $BUILD_PATH /Firmware.ino.elf $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT -EN_ONLY.elf || exit 47
2021-02-12 19:12:37 +00:00
fi
# Cleanup Firmware
if [ [ -z " $prusa_flag " || " $prusa_flag " = = "0" ] ] ; then
2021-05-03 06:24:02 +00:00
rm $SCRIPT_PATH /Firmware/Configuration_prusa.h || exit 53
2021-02-12 19:12:37 +00:00
fi
2021-05-03 06:24:02 +00:00
# Delete dupblicates
2021-02-12 19:12:37 +00:00
if find $SCRIPT_PATH /lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
then
rm $SCRIPT_PATH /lang/*RAMBo10a*.txt
fi
2021-05-03 06:24:02 +00:00
# MK2 not supported in this branch
2021-02-12 19:12:37 +00:00
if find $SCRIPT_PATH /lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
then
rm $SCRIPT_PATH /lang/*MK2-RAMBo13a*.txt
fi
if find $SCRIPT_PATH /lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
then
rm $SCRIPT_PATH /lang/not_tran.txt
fi
if find $SCRIPT_PATH /lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
then
rm $SCRIPT_PATH /lang/not_used.txt
fi
#New fresh PF-Firmware-build
if [ " $new_build_flag " = = "1" ] ; then
2021-05-03 06:24:02 +00:00
rm -r -f $BUILD_PATH /* || exit 54
2021-02-12 19:12:37 +00:00
fi
# Restore files to previous state
sed -i -- " s/^#define FW_DEV_VERSION FW_VERSION_ $DEV_STATUS /#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g " $SCRIPT_PATH /Firmware/Configuration.h
sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH /Firmware/Configuration.h
if [ ! -z " $BUILD_ORG " ] ; then
sed -i -- " s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG /g " $SCRIPT_PATH /Firmware/Configuration.h
fi
echo $MULTI_LANGUAGE_CHECK
#sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
sed -i -- " s/^#define LANG_MODE *1/#define LANG_MODE ${ MULTI_LANGUAGE_CHECK } /g " $SCRIPT_PATH /Firmware/config.h
sed -i -- " s/^#define LANG_MODE *0/#define LANG_MODE ${ MULTI_LANGUAGE_CHECK } /g " $SCRIPT_PATH /Firmware/config.h
if [ $OUTPUT = = "1" ] ; then
sleep 5
fi
2021-05-03 18:01:48 +00:00
# Restore build env files to previous state
sed -i -- " s/^#define FLASHEND .* $/#define FLASHEND 0x3FFFF/g " $BUILD_ENV_PATH /hardware/tools/avr/avr/include/avr/iom2560.h
sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH /portable/packages/$BOARD_PACKAGE_NAME /hardware/avr/$BOARD_VERSION /boards.txt
sed -i -- "s/^#define RAMEND.*/#define RAMEND 0x21FF/g" $BUILD_ENV_PATH /hardware/tools/avr/avr/include/avr/iom2560.h
2019-02-16 05:05:43 +00:00
done
# Switch to hex path and list build files
cd $SCRIPT_PATH
echo " $( tput setaf 2) "
echo " "
echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
echo " more information how to flash firmware https://www.prusa3d.com/drivers/ $( tput sgr 0) "
#### End building
2021-02-13 09:35:34 +00:00
#### MK404 Simulator
# Check/compile MK404 sim
2021-02-12 19:12:37 +00:00
if [ ! -z " $mk404_flag " ] ; then
2021-05-03 06:24:02 +00:00
./MK404-build.sh -c1 || exit 61
2021-02-12 19:12:37 +00:00
2021-02-13 23:18:24 +00:00
# For Prusa MK2, MK2.5/S
2021-03-17 17:33:54 +00:00
if [ " $MOTHERBOARD " = = "BOARD_RAMBO_MINI_1_3" ] ; then
2021-05-03 12:11:03 +00:00
MK404_PRINTER = " ${ MK404_PRINTER } _mR13 "
2021-03-17 17:33:54 +00:00
else
if [ [ " $mk404_flag " = = "2" || " $mk404_flag " = = "MMU2" || " $mk404_flag " = = "MMU2S" ] ] ; then # Check if MMU2 is selected only for MK3/S
2021-05-03 12:11:03 +00:00
MK404_PRINTER = " ${ MK404_PRINTER } MMU2 "
2021-03-17 17:33:54 +00:00
fi
fi
2021-02-12 19:12:37 +00:00
2021-05-05 18:05:35 +00:00
# Run MK404 with 'debugcore' and/or 'bootloader-file'
2021-05-03 18:01:48 +00:00
echo " MK404_DEBUG -- $MK404_DEBUG -- "
if [ " $MK404_DEBUG " = = "atmega404" ] ; then
MK404_options = "--debugcore"
elif [ " $MK404_DEBUG " = = "atmega404_no_bootloader" ] ; then
2021-05-05 18:05:35 +00:00
MK404_options = '--debugcore --bootloader-file ""'
2021-05-03 18:01:48 +00:00
fi
2021-02-13 23:18:24 +00:00
2021-02-13 09:35:34 +00:00
# Run MK404 with grafics
2021-03-17 17:33:54 +00:00
if [ ! -z " $graphics_flag " ] ; then
2021-05-03 18:01:48 +00:00
echo " MK404_options -- $MK404_options -- "
if [ ! -z " $MK404_options " ] ; then
MK404_options = " ${ MK404_options } --colour-extrusion --extrusion Quad_HR -g "
else
MK404_options = "--colour-extrusion --extrusion Quad_HR -g "
fi
2021-03-17 17:33:54 +00:00
if [ [ " $graphics_flag " = = "1" || " $graphics_flag " = = "lite" ] ] ; then
MK404_options = " ${ MK404_options } lite "
elif [ [ " $graphics_flag " = = "2" || " $graphics_flag " = = "fancy" ] ] ; then
MK404_options = " ${ MK404_options } fancy "
else
echo " $( tput setaf 1) Unsupported MK404 graphics option $graphics_flag $( tput sgr 0) "
fi
2021-02-12 19:12:37 +00:00
fi
2021-02-13 09:35:34 +00:00
# Output some useful data
2021-05-03 12:11:03 +00:00
echo " Printer: $MK404_PRINTER "
2021-03-17 17:33:54 +00:00
echo " Options: $MK404_options "
2021-02-13 09:35:34 +00:00
# Change to MK404 build folder
2021-03-17 17:33:54 +00:00
cd ../MK404/master/build
2021-02-13 09:35:34 +00:00
# Copy language bin file for MK3 and MK3S to xflash
2021-05-03 05:00:15 +00:00
# if [ -f $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin ]; then
2021-05-03 12:11:03 +00:00
# echo "Copy 'FW$FW-Build$BUILD-$VARIANT-lang.bin' to 'Prusa_${MK404_PRINTER}_xflash.bin'"
# dd if=/dev/zero bs=1 count=262145 | tr "\000" "\377" >Prusa_${MK404_PRINTER}_xflash.bin
# dd if=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin of=Prusa_${MK404_PRINTER}_xflash.bin conv=notrunc
2021-05-03 05:00:15 +00:00
# fi
2021-02-12 19:12:37 +00:00
2021-04-30 23:30:03 +00:00
#Decide which hex file to use EN_ONLY or Multi language
if [ " $LANGUAGES " = = "ALL" ] ; then
MK404_firmware_file = $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT .hex
else
MK404_firmware_file = $SCRIPT_PATH /../$OUTPUT_FOLDER /FW$FW -Build$BUILD -$VARIANT -EN_ONLY.hex
fi
2021-02-13 09:35:34 +00:00
# Start MK404
# default with serial output and terminal to manipulate it via terminal
2021-05-03 12:11:03 +00:00
./MK404 Prusa_$MK404_PRINTER -s --terminal $MK404_options -f $MK404_firmware_file || exit 62
2021-02-12 19:12:37 +00:00
fi
2021-03-17 17:33:54 +00:00
#### End of MK404 Simulator